# -*- coding: utf-8 -*-

# Common modules import
import cherrypy
from mako.template import Template
from mako.lookup import TemplateLookup

# International support
supported_languages = ['en_US','pt_PT']

mylookup = None

def set_templates_directory(directory):
    global mylookup
    print "Template set to ", directory
    # Template rendering with internationalization support
    mylookup = TemplateLookup(directories=[directory], \
        module_directory='/tmp/mako_modules', \
        output_encoding='utf-8', encoding_errors='replace')

def serve_template(templatename, **kwargs):
    mytemplate = mylookup.get_template(templatename)
    kwargs["_"] = translate_string 
    # Check if we need to use a lang prefix
    lang = url_language()
    if lang:
        lang = "/"+lang
    else:
        lang = ""
    kwargs["lang"] = lang
    return mytemplate.render(**kwargs)

def _(str):    
    # Translation string will be implemeneted here
    return str

def url_language():
    """ Returns the language part of the url http://server/lang/* """
    url_lang = cherrypy.request.path_info.split("/",2)[1]
    print "url_lang=", url_lang
    if url_lang in supported_languages:
        return url_lang
    return None

def translate_string(str):    
    # Translation string will be implemeneted here
    if url_language() == "pt_PT" and str == "Hello":
        return u"Olá"
    return str
